<template>
  <div class="flex flex-col justify-start relative w-full h-full">
    <div class="text-xl md:text-2xl font-bold tracking-[2%] lobby-title">
      {{ $t("sports_betting") }}
    </div>
    <div class="sports-container-wrapper">
      <template v-for="(sport, index) in playableSportForDisplay" :key="index">
        <div
          class="bg-star rounded-lg sm:rounded-2xl cursor-pointer md:cursor-default"
          :style="`background: url(${getAssetImage(
            `assets/theme/common/LobbySettings/SportsModule/Sports_Module_04/bg_card.png`
          )})`"
          @click="onSportRedirect(sport.GameId)"
          @mouseenter="(event) => handleMouseAction(event, true)"
          @mouseleave="(event) => handleMouseAction(event, false)"
        >
          <div class="star w-full md:h-[280px]">
            <img
              :src="sport.StarImagePath"
              class="w-full object-contain object-top rounded-2xl"
            />
          </div>
          <div
            class="content-gradient-mask-wrapper"
            :style="`background:${sport.maskColor}`"
          ></div>
          <div class="content-mask-wrapper"></div>
          <div class="content-wrapper">
            <div
              v-if="providerCount[sport.GameProviderName] > 1"
              class="provider-logo-wrapper !h-auto"
            >
              <img
                :src="sport.ProviderLogoCenterPath"
                class="w-full object-contain object-center"
              />
              <p
                v-if="providerCount[sport.GameProviderName] > 1"
                class="w-auto h-[21px] text-lg font-bold game-name-text"
              >
                {{ sport.GameName }}
              </p>
            </div>
            <div v-else class="provider-logo-wrapper !h-auto">
              <img
                :src="sport.ProviderLogoCenterPath"
                class="w-full object-contain object-center"
              />
            </div>
            <nuxt-link
              :to="
                isAuthenticated
                  ? `/Game/${sport.GameId}?tab=Sports&&entrance=${EnumEntranceLocation.GameLobby}`
                  : '/login'
              "
              class="provider-playnow-button hidden md:block"
            >
              <div class="w-full h-full truncate px-4" type="primary">
                {{ $t("play_now") }}
              </div>
            </nuxt-link>
          </div>
          <div class="flare-effect-wrapper"></div>
        </div>
      </template>
    </div>
  </div>
</template>
<script setup lang="ts">
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { store } from "~~/store";
import useSportModule from "@/composables/lobby/useSportModule";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";
import { ILobbySettingsText } from "~~/models/customizeTheme";
const { getAssetImage } = commonHelper;
const props = defineProps<{
  data: ILobbySettingsText;
}>();
const isAuthenticated = computed(() => store.state.auth);
interface ISportProvider {
  provider: string;
  maskColor: string;
}
const router = useRouter();
const { toggleLoginRegisterDialog } = commonHelper;
const { playableGame } = useSportModule(props.data);
const sports: ISportProvider[] = [
  {
    provider: "digitain",
    maskColor:
      "linear-gradient(180deg, rgba(82, 91, 163, 0) 0%, #525BA3 74.16%)",
  },
  {
    provider: "saba_sports",
    maskColor:
      "linear-gradient(180deg, rgba(206, 106, 106, 0) 0%, #CE6A6A 74.16%)",
  },
  {
    provider: "568win_sports",
    maskColor:
      "linear-gradient(180deg, rgba(69, 147, 190, 0) 0%, #4593BE 74.16%)",
  },
  {
    provider: "bti_sports",
    maskColor:
      "linear-gradient(180deg, rgba(200, 171, 98, 0) 0%, #C8AB62 74.16%)",
  },
];
const providerCount = textHelper.checkMultiple(playableGame.value);
const playableSportForDisplay = computed(() => {
  return playableGame.value.slice(0, 4).map((sport, index) => {
    return {
      ...sport,
      ...{
        ProviderLogoCenterPath: sport.ProviderLogoCenterPath,
        StarImagePath: sport.StarImagePath,
        maskColor: sports[index].maskColor,
      },
    };
  });
});
let hoverTimeout: number;
const handleMouseAction = (element: MouseEvent, isEntering: boolean) => {
  const target = element.target as HTMLElement;
  clearTimeout(hoverTimeout);
  if (isEntering) {
    hoverTimeout = window.setTimeout(() => {
      if (target) {
        target.classList.add("sport-card-hover");
      }
    }, 600);
  } else if (target) {
    target.classList.remove("sport-card-hover");
  }
};
const onSportRedirect = (gameId: number) => {
  if (window.innerWidth < 768) {
    if (isAuthenticated.value) {
      router.push(
        `/Game/${gameId}?tab=Sports&&entrance=${EnumEntranceLocation.GameLobby}`
      );
    } else {
      toggleLoginRegisterDialog();
    }
  }
};
</script>
<style lang="scss">
.sports-container-wrapper {
  @apply grid grid-flow-col auto-cols-[42%] md:flex items-center justify-start md:justify-center gap-2 p-2 my-0 mx-0 md:mx-[-14px] overflow-x-auto md:overflow-x-visible
   overflow-y-hidden md:overflow-y-visible;

  &::-webkit-scrollbar {
    display: none;
  }

  .bg-star {
    @apply relative aspect-[152/196] xl:w-[288px] xl:h-[384px] xl:aspect-[unset] flex justify-center items-center overflow-hidden z-10;
    //width: unset !important;
  }

  .content-mask-wrapper {
    @apply absolute w-full h-full rounded-2xl z-10;
    background: rgba(0, 0, 0, 1);
    opacity: 0;
    transition: opacity 300ms ease-in-out 200ms;
  }

  .content-gradient-mask-wrapper {
    @apply absolute w-full h-[calc(100%-58.5px)] md:h-[262px] z-20 bottom-0;
  }

  .content-wrapper {
    @apply absolute w-full h-full md:h-[352px] z-20 flex flex-col justify-end items-center;

    .provider-logo-wrapper {
      @apply flex flex-col items-center justify-center gap-1 w-[calc(100%-46px)] md:w-[200px] md:h-[80px] pb-[11px] md:pb-0;
      .game-name-text {
        transition: all 300ms ease-out;
      }
    }

    .provider-name-wrapper {
      @apply text-lg tracking-[2%] font-bold;
    }

    .provider-playnow-button {
      @apply absolute cursor-pointer tracking-[2%] font-bold w-[176px] h-[44px] leading-[44px] text-center opacity-0;
      transform: scale(0.9114, 0.91);
      background: var(--primary);
      color: var(--text5);
      border-radius: 8.8px;
      font-size: 19.8px;
      bottom: 0;
      transition: bottom 400ms ease-in-out, opacity 400ms ease-in-out;
    }
  }

  .flare-effect-wrapper {
    @apply absolute rounded-2xl z-50;
    width: 753.7px;
    height: 117px;
    opacity: 0.2;
    background: linear-gradient(
      181.19deg,
      rgba(255, 255, 255, 0) 12.52%,
      #ffffff 98.99%
    );
    transition: opacity 200ms ease-in-out 200ms;
    animation: flareLeftToRight 3s ease-in-out infinite;
  }

  @keyframes flareLeftToRight {
    0% {
      transform: translate(-50%, -50%) rotate(-30deg);
    }

    100% {
      transform: translate(50%, 50%) rotate(-30deg);
    }
  }
}

@media screen and (min-width: 640px) {
  .sports-container-wrapper {
    @apply gap-4 px-0 pt-5;

    .content-mask-wrapper {
      opacity: 0;
    }

    .flare-effect-wrapper {
      width: 900.7px;
      animation: flareLeftToRight 1600ms ease-out infinite;
    }
  }
}

@media screen and (min-width: 768px) {
  .sports-container-wrapper {
    @apply gap-4 px-0 pt-5;

    .bg-star {
      @apply relative w-full aspect-[152/196] lg:w-[288px] lg:h-[384px] lg:aspect-[unset] rounded-2xl flex justify-center items-center overflow-hidden z-10;
      transition: transform 300ms ease-out, margin 300ms ease-out;

      &:hover {
        transform: scale(1.09721, 1.09895);
        margin: 0 14px;

        .content-mask-wrapper {
          opacity: 0;
        }
        .provider-logo-wrapper {
          .game-name-text {
            font-size: 20px;
          }
        }
        .provider-playnow-button {
          opacity: 1;
          bottom: 45%;
        }
      }
    }

    .content-mask-wrapper {
      opacity: 0.4;
    }

    .sport-card-hover:hover .flare-effect-wrapper {
      @apply absolute rounded-2xl z-50;
      display: unset;
      width: 1007px;
      height: 221px;
      opacity: 0.2;
      background: linear-gradient(
        181.19deg,
        rgba(255, 255, 255, 0) 12.52%,
        #ffffff 98.99%
      );
      transition: opacity 200ms ease-in-out 200ms;
      animation: flareLeftToRight 1600ms ease-out infinite;
    }

    .flare-effect-wrapper {
      display: none;
    }
  }
}
</style>
